/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   bastl@server                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "werkzeugeview.h"
#include "w_use.h"

#include <qcombobox.h>
#include <qfile.h>
#include <qdir.h>
#include <qlineedit.h>
#include <qstring.h>
#include <qcstring.h>
#include <qcheckbox.h>
#include <qmessagebox.h>
#include <qevent.h>
#include <qtabwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qframe.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include <kmessagebox.h>
#include <knuminput.h>
#include <kdialog.h>
#include <klocale.h>
#include <knuminput.h>

#include <cstdlib>
#include <unistd.h>
#include <math.h>



static const unsigned char img0_werkzeuge[] =
	{
	0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a, 0x00, 0x00, 0x00, 0x0d,
	0x49, 0x48, 0x44, 0x52, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x20,
	0x08, 0x06, 0x00, 0x00, 0x00, 0x73, 0x7a, 0x7a, 0xf4, 0x00, 0x00, 0x01,
	0xb9, 0x49, 0x44, 0x41, 0x54, 0x58, 0x85, 0xed, 0x97, 0xb1, 0xb2, 0xc2,
	0x20, 0x10, 0x45, 0x4f, 0xec, 0xd2, 0x33, 0xf6, 0x94, 0xf2, 0x2b, 0xfe,
	0xaa, 0x76, 0xbe, 0x4f, 0x09, 0x76, 0xd2, 0x33, 0xd4, 0xa6, 0xdc, 0x57,
	0x48, 0xf2, 0x30, 0x02, 0x8f, 0xcc, 0x38, 0x19, 0x0b, 0xab, 0xcc, 0x66,
	0x13, 0xc2, 0xbd, 0x7b, 0xb9, 0xbb, 0xe9, 0xc4, 0x8b, 0x8c, 0x81, 0x0e,
	0x85, 0xb8, 0x40, 0x67, 0x14, 0x9b, 0xc6, 0x3b, 0x1b, 0x5c, 0x0c, 0x1c,
	0x5a, 0x21, 0x36, 0x38, 0xb6, 0x8c, 0xbb, 0xbb, 0x17, 0x71, 0x01, 0x8c,
	0x82, 0x31, 0x00, 0x0a, 0x36, 0x8c, 0xbb, 0x9d, 0x0b, 0xae, 0xd3, 0x0a,
	0xe2, 0xce, 0x88, 0x3b, 0xdb, 0x2a, 0x96, 0x2e, 0x6a, 0x60, 0x6b, 0xe4,
	0x53, 0x3c, 0x6b, 0x60, 0x6b, 0xe4, 0x7c, 0x8c, 0x06, 0x18, 0xec, 0x8d,
	0xbb, 0x17, 0x19, 0xec, 0x4d, 0xa6, 0xab, 0x30, 0x88, 0x70, 0x12, 0x61,
	0x78, 0xba, 0x9f, 0x5e, 0xa7, 0xbc, 0x70, 0xca, 0xe6, 0x5b, 0xd7, 0xc9,
	0x6a, 0x80, 0xfd, 0x0f, 0xa0, 0x01, 0x07, 0xfe, 0x98, 0x45, 0xd2, 0x1b,
	0xfb, 0xc8, 0xa3, 0x19, 0xad, 0xc9, 0x22, 0xed, 0x93, 0x75, 0x46, 0x7f,
	0x5c, 0xa1, 0x01, 0x34, 0x70, 0x05, 0x74, 0xb1, 0x86, 0x53, 0x1e, 0xae,
	0xc5, 0x1a, 0xa7, 0xeb, 0xac, 0xd2, 0x40, 0xc3, 0xce, 0x31, 0x09, 0x03,
	0xd6, 0x9a, 0x6c, 0x8d, 0x1b, 0x98, 0xcc, 0xfb, 0xc0, 0xe8, 0x8f, 0xf3,
	0xce, 0xfb, 0xfd, 0xf9, 0x65, 0xe7, 0x8f, 0x8f, 0xff, 0x31, 0x60, 0x8c,
	0x7d, 0x61, 0x8a, 0xfd, 0x79, 0xce, 0x8f, 0xfe, 0xb8, 0xde, 0x07, 0x6a,
	0x35, 0x7e, 0x42, 0x56, 0x60, 0xaa, 0x45, 0x23, 0x55, 0x1f, 0xa8, 0xd6,
	0x38, 0x41, 0x56, 0xaa, 0x71, 0x8b, 0x46, 0xb4, 0x42, 0x76, 0x5a, 0xe9,
	0xa8, 0x01, 0x0d, 0x01, 0xb4, 0xd2, 0xb8, 0x00, 0x70, 0x88, 0x08, 0x0e,
	0xa4, 0x79, 0x63, 0xc6, 0xf9, 0x3e, 0xc9, 0x73, 0xc6, 0x8c, 0x4d, 0xef,
	0x4f, 0xf9, 0x18, 0x57, 0x7a, 0x81, 0xed, 0x67, 0x04, 0x35, 0x64, 0x25,
	0xa4, 0xf3, 0x29, 0xb2, 0x7d, 0xb5, 0x17, 0x20, 0x5e, 0xe4, 0x6e, 0x25,
	0x9a, 0x83, 0x48, 0x1a, 0x0b, 0x97, 0x68, 0x26, 0x97, 0xbf, 0x7c, 0x8c,
	0x1f, 0xe6, 0x92, 0x89, 0x17, 0xef, 0xd5, 0xd6, 0x1f, 0xac, 0x50, 0xed,
	0x05, 0xb9, 0x73, 0xfc, 0x82, 0x2c, 0xc7, 0x54, 0x83, 0x8f, 0x4c, 0x1a,
	0xa0, 0xb0, 0xb3, 0x2c, 0x92, 0x12, 0xb2, 0x25, 0x53, 0x59, 0xe6, 0xf2,
	0x4c, 0x50, 0x9d, 0x07, 0x52, 0x95, 0xd7, 0x90, 0x2d, 0x99, 0x4a, 0x4f,
	0xc9, 0x7f, 0xf3, 0x40, 0x55, 0x03, 0x69, 0x8d, 0x6b, 0xc8, 0x4a, 0x4c,
	0x55, 0x90, 0xb7, 0x69, 0x20, 0xad, 0x79, 0xbf, 0x70, 0xb6, 0x12, 0x53,
	0xa9, 0x03, 0xbe, 0x65, 0x1e, 0x48, 0x1d, 0xad, 0xea, 0xfd, 0x99, 0xe7,
	0x2a, 0x0e, 0xd8, 0x3e, 0x13, 0xa6, 0x2a, 0xaf, 0x9e, 0xeb, 0xcc, 0x73,
	0x6f, 0x9b, 0x09, 0x5b, 0xe6, 0x83, 0xe6, 0x2e, 0xda, 0xda, 0x0b, 0xd6,
	0xce, 0x07, 0x8d, 0xfd, 0xff, 0xf3, 0x66, 0xc2, 0xef, 0x7f, 0xc1, 0xf7,
	0xbf, 0x20, 0xd5, 0xc0, 0xc4, 0xc4, 0x96, 0xb1, 0xfc, 0x02, 0xb0, 0xb9,
	0xff, 0xbe, 0x4f, 0x4f, 0x6c, 0xa8, 0x00, 0x00, 0x00, 0x00, 0x49, 0x45,
	0x4e, 0x44, 0xae, 0x42, 0x60, 0x82
	};

static const unsigned char img2_werkzeuge[] =
	{
	0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a, 0x00, 0x00, 0x00, 0x0d,
	0x49, 0x48, 0x44, 0x52, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x1a,
	0x08, 0x06, 0x00, 0x00, 0x00, 0xeb, 0x09, 0x3f, 0x59, 0x00, 0x00, 0x02,
	0xa8, 0x49, 0x44, 0x41, 0x54, 0x58, 0x85, 0xed, 0x97, 0xc1, 0x6a, 0x1b,
	0x31, 0x10, 0x86, 0xbf, 0x2d, 0x73, 0xd8, 0x7d, 0x8c, 0xe4, 0x52, 0x68,
	0x6e, 0xed, 0xd9, 0x81, 0x80, 0xa1, 0x5b, 0x41, 0xe9, 0x73, 0x34, 0x57,
	0xbf, 0x59, 0x6b, 0x5c, 0x07, 0x52, 0x02, 0x36, 0x3d, 0xb6, 0xb7, 0xf4,
	0x98, 0x3e, 0x86, 0x7d, 0x10, 0xa8, 0x87, 0xb5, 0x6c, 0x69, 0x56, 0x5a,
	0xad, 0xd3, 0xe4, 0x90, 0x34, 0x3f, 0x84, 0x78, 0xa4, 0x59, 0x49, 0x33,
	0xff, 0xce, 0x3f, 0x5a, 0x78, 0xc1, 0x0b, 0x9e, 0x15, 0xaa, 0xd4, 0xa0,
	0x1b, 0xe3, 0xf4, 0x44, 0xf1, 0x6a, 0x8c, 0x93, 0x4e, 0xc0, 0x53, 0x86,
	0x14, 0xe6, 0xc3, 0x58, 0x1f, 0x95, 0xe8, 0x8b, 0xe9, 0x05, 0x8d, 0x34,
	0x60, 0x61, 0x71, 0xbd, 0x38, 0x7a, 0x3e, 0x84, 0x69, 0x0d, 0x1b, 0xbb,
	0xa1, 0x91, 0x86, 0xc5, 0x32, 0xf6, 0x1d, 0xc5, 0xf0, 0x63, 0xc3, 0xb4,
	0x86, 0x99, 0xcc, 0x00, 0xb8, 0x94, 0x4b, 0x4c, 0x6b, 0xf6, 0x73, 0xf3,
	0x76, 0x9e, 0x9c, 0x9f, 0xb7, 0xf3, 0xe4, 0x3a, 0x7e, 0xdc, 0xfb, 0xfb,
	0xe7, 0x3d, 0x7a, 0xac, 0xdd, 0x02, 0x6f, 0x0e, 0xe6, 0x9e, 0xe1, 0x5f,
	0x50, 0xbd, 0xfb, 0x97, 0xa8, 0x12, 0x08, 0x99, 0xc0, 0x02, 0x82, 0x0b,
	0x98, 0xa9, 0x20, 0x66, 0x16, 0x41, 0xfb, 0x47, 0x0c, 0x26, 0xd6, 0x8b,
	0xec, 0xc5, 0xf5, 0x22, 0x66, 0xf8, 0x56, 0xa2, 0x60, 0x23, 0xbc, 0x05,
	0x5c, 0xa6, 0x00, 0x7c, 0x66, 0xc3, 0x4c, 0x0e, 0x8d, 0x87, 0x08, 0x98,
	0x73, 0xa1, 0xed, 0x9f, 0x0f, 0x99, 0x55, 0xfe, 0xd1, 0x3a, 0x9a, 0xd9,
	0x9c, 0xff, 0x9e, 0xe1, 0x3b, 0x81, 0x13, 0xdb, 0x3b, 0x4f, 0xaf, 0x86,
	0xff, 0x00, 0xa7, 0x89, 0x80, 0x75, 0x26, 0xfd, 0x78, 0x98, 0xe9, 0x9b,
	0xeb, 0x9b, 0xde, 0x06, 0x66, 0x6a, 0x5c, 0x8a, 0xb9, 0x8d, 0xdd, 0x54,
	0x43, 0xcc, 0xea, 0xfd, 0x4a, 0x6f, 0x82, 0xdf, 0x7f, 0xcf, 0xf0, 0xa9,
	0xed, 0x22, 0xf2, 0x7f, 0x1a, 0x7e, 0x5c, 0x07, 0x0b, 0xdd, 0x6b, 0xa5,
	0x33, 0xe9, 0x33, 0xae, 0x33, 0xad, 0x91, 0x63, 0xe2, 0x31, 0x6c, 0xd3,
	0x9a, 0xbc, 0xf2, 0xba, 0xe8, 0x1f, 0x54, 0x05, 0x95, 0x36, 0x53, 0x33,
	0x8a, 0x09, 0x0d, 0xc5, 0x8c, 0x0b, 0xfc, 0xab, 0x5c, 0xcd, 0xa6, 0xde,
	0x9c, 0xd4, 0xfe, 0x29, 0xe6, 0x1f, 0x4c, 0xa5, 0x83, 0x4c, 0x9e, 0x01,
	0xab, 0x5d, 0x4d, 0xae, 0x76, 0x76, 0x4f, 0x7d, 0x3d, 0x8e, 0x61, 0x2a,
	0x14, 0xa8, 0x92, 0xbf, 0x4f, 0x6e, 0xb6, 0x86, 0x35, 0x8e, 0x65, 0x38,
	0xc8, 0xe4, 0x0a, 0x61, 0x12, 0x64, 0x7a, 0x8d, 0x70, 0x9e, 0xeb, 0x8b,
	0xea, 0x79, 0x37, 0x54, 0xc3, 0x5e, 0x03, 0x52, 0x9a, 0xa1, 0x99, 0xf4,
	0xfb, 0x68, 0xe6, 0x1f, 0x8c, 0xe1, 0x20, 0x93, 0x93, 0x9c, 0x9d, 0x0b,
	0x56, 0xf9, 0x0f, 0xda, 0x63, 0xfd, 0x3d, 0xf4, 0xfc, 0x41, 0xa5, 0x81,
	0x93, 0xfe, 0x39, 0xfa, 0x2a, 0x2d, 0x9d, 0xc0, 0x69, 0x04, 0x99, 0x5c,
	0x35, 0xd2, 0x4c, 0x02, 0x66, 0xd6, 0x8d, 0x34, 0xe7, 0x43, 0xc1, 0x06,
	0xcf, 0x0f, 0xd6, 0x70, 0x4e, 0x8d, 0x53, 0xcc, 0xfb, 0x5a, 0xd7, 0x1a,
	0x70, 0x50, 0x69, 0x28, 0x5f, 0x34, 0xe9, 0x5a, 0x97, 0x93, 0x3a, 0x3e,
	0x6c, 0x6b, 0xc2, 0x4c, 0x7e, 0x06, 0xd6, 0x3b, 0x7b, 0xbd, 0xb3, 0x8b,
	0x18, 0x53, 0xc3, 0x43, 0x7d, 0xd9, 0x23, 0xbc, 0x61, 0xa5, 0xd6, 0x8b,
	0xea, 0xd2, 0x09, 0x1f, 0xb1, 0x7c, 0x29, 0x9e, 0x4e, 0xea, 0x4f, 0x95,
	0xdd, 0xee, 0xfd, 0x4a, 0x37, 0x9c, 0xa1, 0x3e, 0xec, 0x31, 0xa6, 0x86,
	0x4b, 0xea, 0xaf, 0xd5, 0x3b, 0xe5, 0xbf, 0x67, 0xd8, 0x49, 0x0d, 0x96,
	0xaf, 0x48, 0xdd, 0x16, 0x82, 0x6d, 0x61, 0x1b, 0x25, 0x25, 0xd5, 0x87,
	0x4b, 0x4c, 0x68, 0xf8, 0x64, 0xdc, 0xb7, 0xcf, 0x7a, 0x94, 0xfc, 0x15,
	0xc3, 0x35, 0xd8, 0x2d, 0x08, 0xef, 0xb1, 0x2c, 0x93, 0xc1, 0xda, 0xed,
	0x15, 0x52, 0x53, 0xd9, 0x6d, 0x34, 0x75, 0xdf, 0x3e, 0x1c, 0xad, 0xd1,
	0x9a, 0x5e, 0x0d, 0xa7, 0xfa, 0x6e, 0xee, 0x2e, 0x0d, 0xc3, 0x77, 0xef,
	0xde, 0x5d, 0x1a, 0x76, 0x41, 0x58, 0xae, 0x7a, 0x4c, 0xfb, 0x60, 0x33,
	0x48, 0xf5, 0x41, 0xcd, 0xfc, 0xd0, 0x9d, 0x7a, 0x87, 0x6a, 0x26, 0xb3,
	0x0a, 0xa8, 0xc6, 0x32, 0xa7, 0x31, 0xfa, 0x2e, 0xed, 0x11, 0xa9, 0x75,
	0x17, 0xe4, 0x37, 0xa4, 0xfe, 0x80, 0xdd, 0x2e, 0x01, 0x7e, 0x03, 0x67,
	0x89, 0x8d, 0xc6, 0xf6, 0xc1, 0x21, 0xb5, 0x4e, 0x31, 0xa9, 0xbf, 0x86,
	0x72, 0xcc, 0x0e, 0x9d, 0xa7, 0xf4, 0x66, 0xf1, 0x53, 0xba, 0x7e, 0xe4,
	0x80, 0xbb, 0xba, 0x7e, 0xed, 0x7f, 0xe7, 0xbe, 0x96, 0x9e, 0x05, 0xbe,
	0x07, 0x41, 0x3b, 0xba, 0x4f, 0xc7, 0x67, 0x8f, 0x1f, 0xf2, 0x1f, 0x30,
	0xab, 0x71, 0x59, 0xd7, 0x65, 0xa7, 0x27, 0x84, 0xbf, 0x42, 0xe0, 0x16,
	0xcc, 0x00, 0x2d, 0xf4, 0xad, 0x00, 0x00, 0x00, 0x00, 0x49, 0x45, 0x4e,
	0x44, 0xae, 0x42, 0x60, 0x82
	};

static const unsigned char img3_werkzeuge[] =
	{
	0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a, 0x00, 0x00, 0x00, 0x0d,
	0x49, 0x48, 0x44, 0x52, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x1a,
	0x08, 0x06, 0x00, 0x00, 0x00, 0xeb, 0x09, 0x3f, 0x59, 0x00, 0x00, 0x01,
	0xb3, 0x49, 0x44, 0x41, 0x54, 0x58, 0x85, 0xed, 0x96, 0xb1, 0x4e, 0xc3,
	0x30, 0x10, 0x40, 0x9f, 0xd1, 0x0d, 0xe4, 0x33, 0x60, 0x41, 0x82, 0x8d,
	0xbd, 0x48, 0x91, 0x22, 0xd5, 0xba, 0xa1, 0xff, 0x41, 0xd6, 0x7c, 0x07,
	0x2b, 0xff, 0x01, 0x44, 0x51, 0x87, 0x22, 0xa4, 0x76, 0x66, 0xec, 0x0a,
	0x9f, 0xd1, 0x25, 0x92, 0x19, 0xa8, 0x8b, 0x13, 0x08, 0x04, 0x91, 0x50,
	0x05, 0xf2, 0x24, 0x4b, 0x3d, 0xdb, 0xa9, 0x7d, 0x7a, 0xbd, 0x5c, 0x61,
	0x64, 0x64, 0xe4, 0xcf, 0x92, 0x1e, 0x1e, 0x9e, 0xec, 0xfb, 0x0e, 0xbf,
	0xc6, 0x1a, 0xac, 0x03, 0x77, 0x2f, 0xd8, 0x7d, 0xdf, 0xa5, 0x77, 0xd6,
	0xc2, 0xd4, 0x81, 0xf3, 0xe3, 0x5e, 0x98, 0xee, 0xfb, 0x4e, 0xbd, 0xb1,
	0xa6, 0x9a, 0xac, 0x1f, 0x8f, 0xf4, 0x9f, 0xb4, 0x5a, 0x75, 0x71, 0x12,
	0x3b, 0xb5, 0xea, 0xfa, 0x3a, 0xe3, 0x20, 0x0c, 0xd6, 0xc2, 0xf4, 0x14,
	0xe6, 0x1f, 0x6d, 0x3c, 0x87, 0xb9, 0xeb, 0xd1, 0x74, 0x6e, 0x73, 0x07,
	0x90, 0x49, 0xd6, 0xd7, 0x11, 0x00, 0x18, 0xff, 0xe1, 0x49, 0x98, 0x1d,
	0x95, 0xdc, 0x7c, 0xf5, 0xc0, 0x33, 0xcc, 0x8e, 0xe1, 0xae, 0xab, 0x0b,
	0x68, 0xa2, 0x0e, 0x81, 0x4d, 0xb9, 0x21, 0x92, 0x08, 0x4a, 0xd8, 0xc6,
	0x26, 0x92, 0x88, 0x62, 0x5e, 0x74, 0x75, 0x14, 0x10, 0x18, 0x3e, 0x2e,
	0xb9, 0x35, 0x60, 0xfc, 0x08, 0x37, 0x85, 0xf3, 0x4d, 0xc9, 0xe6, 0x36,
	0x47, 0xad, 0x92, 0xdb, 0xbc, 0xd5, 0xbc, 0x27, 0x95, 0x14, 0x78, 0x33,
	0x5b, 0x8f, 0xbb, 0xc6, 0x34, 0x2d, 0x38, 0x70, 0xc1, 0xa6, 0xc6, 0x7d,
	0x1e, 0x4d, 0xd4, 0x9b, 0xe1, 0x61, 0xf1, 0xb0, 0x9b, 0x8f, 0x93, 0x78,
	0x67, 0xae, 0x58, 0xbc, 0xb7, 0x15, 0xae, 0x23, 0xb8, 0xc0, 0xb4, 0x41,
	0xe8, 0xcf, 0xf0, 0x4f, 0x09, 0xcc, 0x9c, 0xa9, 0xd5, 0x65, 0x6e, 0x73,
	0xa7, 0x56, 0x97, 0x99, 0x64, 0x67, 0x7e, 0x5d, 0xad, 0xbe, 0x7b, 0xae,
	0xc9, 0xac, 0x8f, 0xbb, 0xa6, 0x33, 0xc3, 0x81, 0xa9, 0x25, 0xc2, 0x24,
	0x30, 0xb5, 0x42, 0xb8, 0xf0, 0xf1, 0x67, 0xc6, 0xd4, 0xaa, 0xfb, 0xb5,
	0x1a, 0xfe, 0x29, 0xfe, 0x67, 0x9c, 0x4a, 0x3a, 0x81, 0x8a, 0xa9, 0x5d,
	0xdc, 0xe6, 0xf2, 0x83, 0xa9, 0x61, 0x4f, 0x9c, 0xc4, 0xcb, 0x48, 0xa2,
	0x49, 0x60, 0x6a, 0x15, 0x49, 0x74, 0xd1, 0x26, 0x59, 0xb5, 0x3a, 0x9c,
	0x1a, 0x06, 0x50, 0xab, 0x64, 0x92, 0x5d, 0x02, 0xab, 0xad, 0xa9, 0xd5,
	0x36, 0x6e, 0xcd, 0x60, 0x6a, 0x18, 0x5e, 0x13, 0x0e, 0xcc, 0x56, 0xfa,
	0x6a, 0x5b, 0xc3, 0x83, 0xa9, 0x61, 0xdf, 0x67, 0x9b, 0xde, 0xb6, 0x4d,
	0x7d, 0xb8, 0xce, 0x60, 0x6a, 0x38, 0xec, 0xc3, 0xb5, 0x7f, 0x4c, 0x9f,
	0xf6, 0xe1, 0xca, 0x77, 0x0c, 0xa9, 0x86, 0xeb, 0x66, 0x8a, 0x45, 0x41,
	0x31, 0x2f, 0x2a, 0xa6, 0x3f, 0xea, 0xc3, 0x35, 0x4c, 0x26, 0x99, 0x01,
	0x4c, 0x5f, 0x35, 0xdc, 0x59, 0xc2, 0x57, 0xe5, 0x15, 0x00, 0xd7, 0xe5,
	0x75, 0x65, 0xde, 0xc7, 0x7e, 0xfd, 0x2b, 0xbe, 0xbb, 0x7f, 0x64, 0x64,
	0xe4, 0x7f, 0xf1, 0x02, 0x5f, 0x81, 0xe9, 0xe7, 0x58, 0xd6, 0x10, 0x70,
	0x00, 0x00, 0x00, 0x00, 0x49, 0x45, 0x4e, 0x44, 0xae, 0x42, 0x60, 0x82
	};


/*
 *  Constructs a Werkzeuge as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
WerkzeugeView::WerkzeugeView( QWidget* parent, const char* name, bool modal, WFlags fl ) : QDialog( parent, name, modal, fl )
	{
	QImage img;
	img.loadFromData( img0_werkzeuge, sizeof( img0_werkzeuge ), "PNG" );
	image0 = img;
	img.loadFromData( img2_werkzeuge, sizeof( img2_werkzeuge ), "PNG" );
	image2 = img;
	img.loadFromData( img3_werkzeuge, sizeof( img3_werkzeuge ), "PNG" );
	image3 = img;
	if ( !name )
		setName( "Werkzeuge" );
	setSizePolicy( QSizePolicy(( QSizePolicy::SizeType ) 5, ( QSizePolicy::SizeType ) 0, 0, 0, sizePolicy().hasHeightForWidth() ) );
	setMinimumSize( QSize( 470, 690 ) );
	setMaximumSize( QSize( 470, 32767 ) );
	setIcon( image0 );
	WerkzeugeLayout = new QGridLayout( this, 1, 1, 5, 5, "WerkzeugeLayout" );

	w_abbruch = new QPushButton( this, "w_abbruch" );
	w_abbruch->setMinimumSize( QSize( 0, 30 ) );
	w_abbruch->setMaximumSize( QSize( 140, 32767 ) );

	WerkzeugeLayout->addWidget( w_abbruch, 3, 1 );

	w_beenden = new QPushButton( this, "w_beenden" );
	w_beenden->setMinimumSize( QSize( 0, 30 ) );
	w_beenden->setMaximumSize( QSize( 140, 32767 ) );

	WerkzeugeLayout->addWidget( w_beenden, 3, 2 );

	w_speichern = new QPushButton( this, "w_speichern" );
	w_speichern->setMinimumSize( QSize( 0, 30 ) );
	w_speichern->setMaximumSize( QSize( 140, 32767 ) );

	WerkzeugeLayout->addWidget( w_speichern, 3, 0 );

	w_tab = new QTabWidget( this, "w_tab" );
	w_tab->setSizePolicy( QSizePolicy(( QSizePolicy::SizeType ) 5, ( QSizePolicy::SizeType ) 5, 1, 0, w_tab->sizePolicy().hasHeightForWidth() ) );
	w_tab->setMinimumSize( QSize( 450, 570 ) );
	w_tab->setMaximumSize( QSize( 450, 32767 ) );

	form = new QWidget( w_tab, "form" );
	formLayout = new QGridLayout( form, 1, 1, 10, 5, "formLayout" );

	textLabel7_3 = new QLabel( form, "textLabel7_3" );
	textLabel7_3->setMinimumSize( QSize( 170, 21 ) );
	textLabel7_3->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel7_3_font( textLabel7_3->font() );
	textLabel7_3->setFont( textLabel7_3_font );

	formLayout->addWidget( textLabel7_3, 0, 0 );

	textLabel7_2_2 = new QLabel( form, "textLabel7_2_2" );
	textLabel7_2_2->setMinimumSize( QSize( 170, 21 ) );
	textLabel7_2_2->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel7_2_2_font( textLabel7_2_2->font() );
	textLabel7_2_2->setFont( textLabel7_2_2_font );

	formLayout->addWidget( textLabel7_2_2, 8, 0 );

	textLabel2_4_2_2 = new QLabel( form, "textLabel2_4_2_2" );
	textLabel2_4_2_2->setMinimumSize( QSize( 170, 21 ) );
	textLabel2_4_2_2->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel2_4_2_2_font( textLabel2_4_2_2->font() );
	textLabel2_4_2_2->setFont( textLabel2_4_2_2_font );

	formLayout->addWidget( textLabel2_4_2_2, 6, 0 );

	textLabel2_4_3_2 = new QLabel( form, "textLabel2_4_3_2" );
	textLabel2_4_3_2->setMinimumSize( QSize( 170, 21 ) );
	textLabel2_4_3_2->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel2_4_3_2_font( textLabel2_4_3_2->font() );
	textLabel2_4_3_2->setFont( textLabel2_4_3_2_font );

	formLayout->addWidget( textLabel2_4_3_2, 7, 0 );

	textLabel2_2_2 = new QLabel( form, "textLabel2_2_2" );
	textLabel2_2_2->setMinimumSize( QSize( 170, 21 ) );
	textLabel2_2_2->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel2_2_2_font( textLabel2_2_2->font() );
	textLabel2_2_2->setFont( textLabel2_2_2_font );

	formLayout->addWidget( textLabel2_2_2, 2, 0 );

	werkzeugname = new QLineEdit( form, "werkzeugname" );
	werkzeugname->setMinimumSize( QSize( 0, 21 ) );
	werkzeugname->setMaximumSize( QSize( 32767, 21 ) );
	QFont werkzeugname_font( werkzeugname->font() );
	werkzeugname->setFont( werkzeugname_font );
	werkzeugname->setMaxLength( 32 );

	formLayout->addWidget( werkzeugname, 0, 1 );

	w_radius = new KDoubleNumInput( form, "w_radius" );
	w_radius->setMinimumSize( QSize( 80, 21 ) );
	w_radius->setMaximumSize( QSize( 80, 21 ) );
	QFont w_radius_font( w_radius->font() );
	w_radius->setFont( w_radius_font );
	w_radius->setMinValue( -9999 );

	formLayout->addWidget( w_radius, 5, 1 );

	textLabel2_4_4 = new QLabel( form, "textLabel2_4_4" );
	textLabel2_4_4->setMinimumSize( QSize( 170, 21 ) );
	textLabel2_4_4->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel2_4_4_font( textLabel2_4_4->font() );
	textLabel2_4_4->setFont( textLabel2_4_4_font );

	formLayout->addWidget( textLabel2_4_4, 5, 0 );

	textLabel2_3_2 = new QLabel( form, "textLabel2_3_2" );
	textLabel2_3_2->setMinimumSize( QSize( 170, 21 ) );
	textLabel2_3_2->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel2_3_2_font( textLabel2_3_2->font() );
	textLabel2_3_2->setFont( textLabel2_3_2_font );

	formLayout->addWidget( textLabel2_3_2, 3, 0 );

	w_steigung = new KDoubleNumInput( form, "w_steigung" );
	w_steigung->setMinimumSize( QSize( 80, 21 ) );
	w_steigung->setMaximumSize( QSize( 80, 21 ) );
	QFont w_steigung_font( w_steigung->font() );
	w_steigung->setFont( w_steigung_font );

	formLayout->addWidget( w_steigung, 6, 1 );

	w_l3 = new KDoubleNumInput( form, "w_l3" );
	w_l3->setMinimumSize( QSize( 80, 21 ) );
	w_l3->setMaximumSize( QSize( 80, 21 ) );
	QFont w_l3_font( w_l3->font() );
	w_l3->setFont( w_l3_font );

	formLayout->addWidget( w_l3, 3, 1 );

	textLabel2_7 = new QLabel( form, "textLabel2_7" );
	textLabel2_7->setMinimumSize( QSize( 170, 21 ) );
	textLabel2_7->setMaximumSize( QSize( 170, 21 ) );
	QFont textLabel2_7_font( textLabel2_7->font() );
	textLabel2_7->setFont( textLabel2_7_font );

	formLayout->addWidget( textLabel2_7, 1, 0 );

	w_durchmesser = new KDoubleNumInput( form, "w_durchmesser" );
	w_durchmesser->setMinimumSize( QSize( 80, 21 ) );
	w_durchmesser->setMaximumSize( QSize( 80, 21 ) );
	QFont w_durchmesser_font( w_durchmesser->font() );
	w_durchmesser->setFont( w_durchmesser_font );

	formLayout->addWidget( w_durchmesser, 1, 1 );

	w_l2 = new KDoubleNumInput( form, "w_l2" );
	w_l2->setMinimumSize( QSize( 80, 21 ) );
	w_l2->setMaximumSize( QSize( 80, 21 ) );
	QFont w_l2_font( w_l2->font() );
	w_l2->setFont( w_l2_font );

	formLayout->addWidget( w_l2, 2, 1 );

	w_winkel = new KDoubleNumInput( form, "w_winkel" );
	w_winkel->setMinimumSize( QSize( 80, 21 ) );
	w_winkel->setMaximumSize( QSize( 80, 21 ) );
	QFont w_winkel_font( w_winkel->font() );
	w_winkel->setFont( w_winkel_font );
	w_winkel->setMinValue( -90 );
	w_winkel->setMaxValue( 90 );

	formLayout->addWidget( w_winkel, 8, 1 );

	w_modul = new KDoubleNumInput( form, "w_modul" );
	w_modul->setMinimumSize( QSize( 80, 21 ) );
	w_modul->setMaximumSize( QSize( 80, 21 ) );
	QFont w_modul_font( w_modul->font() );
	w_modul->setFont( w_modul_font );

	formLayout->addWidget( w_modul, 7, 1 );

	line2 = new QFrame( form, "line2" );
	line2->setFrameShape( QFrame::HLine );
	line2->setFrameShadow( QFrame::Sunken );
	line2->setFrameShape( QFrame::HLine );

	formLayout->addMultiCellWidget( line2, 9, 9, 0, 1 );

	line2_2 = new QFrame( form, "line2_2" );
	line2_2->setFrameShape( QFrame::HLine );
	line2_2->setFrameShadow( QFrame::Sunken );
	line2_2->setFrameShape( QFrame::HLine );

	formLayout->addMultiCellWidget( line2_2, 4, 4, 0, 1 );

	textLabel3_2 = new QLabel( form, "textLabel3_2" );
	textLabel3_2->setMinimumSize( QSize( 420, 180 ) );
	textLabel3_2->setMaximumSize( QSize( 32767, 180 ) );
	QFont textLabel3_2_font( textLabel3_2->font() );
	textLabel3_2_font.setPointSize( 10 );
	textLabel3_2->setFont( textLabel3_2_font );
	textLabel3_2->setAlignment( int ( QLabel::WordBreak | QLabel::AlignVCenter ) );

	formLayout->addMultiCellWidget( textLabel3_2, 10, 10, 0, 1 );
	w_tab->insertTab( form, QString::fromLatin1( "" ) );

	verwendung = new QWidget( w_tab, "verwendung" );
	verwendungLayout = new QGridLayout( verwendung, 1, 1, 10, 5, "verwendungLayout" );

	schlicht = new QCheckBox( verwendung, "schlicht" );
	QFont schlicht_font( schlicht->font() );
	schlicht->setFont( schlicht_font );

	verwendungLayout->addWidget( schlicht, 1, 0 );

	klein = new QCheckBox( verwendung, "klein" );
	QFont klein_font( klein->font() );
	klein->setFont( klein_font );

	verwendungLayout->addWidget( klein, 2, 0 );

	seitlich_o = new QCheckBox( verwendung, "seitlich_o" );
	QFont seitlich_o_font( seitlich_o->font() );
	seitlich_o->setFont( seitlich_o_font );

	verwendungLayout->addWidget( seitlich_o, 3, 0 );

	seitlich_u = new QCheckBox( verwendung, "seitlich_u" );
	QFont seitlich_u_font( seitlich_u->font() );
	seitlich_u->setFont( seitlich_u_font );

	verwendungLayout->addWidget( seitlich_u, 4, 0 );

	unten_a = new QCheckBox( verwendung, "unten_a" );
	QFont unten_a_font( unten_a->font() );
	unten_a->setFont( unten_a_font );

	verwendungLayout->addWidget( unten_a, 5, 0 );

	unten_m = new QCheckBox( verwendung, "unten_m" );
	QFont unten_m_font( unten_m->font() );
	unten_m->setFont( unten_m_font );

	verwendungLayout->addWidget( unten_m, 6, 0 );

	nach_u = new QCheckBox( verwendung, "nach_u" );
	QFont nach_u_font( nach_u->font() );
	nach_u->setFont( nach_u_font );

	verwendungLayout->addWidget( nach_u, 7, 0 );

	nach_s = new QCheckBox( verwendung, "nach_s" );
	QFont nach_s_font( nach_s->font() );
	nach_s->setFont( nach_s_font );

	verwendungLayout->addWidget( nach_s, 8, 0 );

	nach_o = new QCheckBox( verwendung, "nach_o" );
	QFont nach_o_font( nach_o->font() );
	nach_o->setFont( nach_o_font );

	verwendungLayout->addWidget( nach_o, 9, 0 );

	textLabel3_2_3 = new QLabel( verwendung, "textLabel3_2_3" );
	textLabel3_2_3->setMinimumSize( QSize( 420, 130 ) );
	textLabel3_2_3->setMaximumSize( QSize( 32767, 130 ) );
	QFont textLabel3_2_3_font( textLabel3_2_3->font() );
	textLabel3_2_3_font.setPointSize( 10 );
	textLabel3_2_3->setFont( textLabel3_2_3_font );
	textLabel3_2_3->setAlignment( int ( QLabel::WordBreak | QLabel::AlignVCenter ) );

	verwendungLayout->addWidget( textLabel3_2_3, 11, 0 );

	line1 = new QFrame( verwendung, "line1" );
	line1->setFrameShape( QFrame::HLine );
	line1->setFrameShadow( QFrame::Sunken );
	line1->setFrameShape( QFrame::HLine );

	verwendungLayout->addWidget( line1, 10, 0 );

	schrup = new QCheckBox( verwendung, "schrup" );
	QFont schrup_font( schrup->font() );
	schrup->setFont( schrup_font );

	verwendungLayout->addWidget( schrup, 0, 0 );
	w_tab->insertTab( verwendung, QString::fromLatin1( "" ) );

	einmessen = new QWidget( w_tab, "einmessen" );
	einmessenLayout = new QGridLayout( einmessen, 10, 1, 10, 5, "einmessenLayout" );

	textLabel1 = new QLabel( einmessen, "textLabel1" );
	textLabel1->setMinimumSize( QSize( 430, 0 ) );
	textLabel1->setMaximumSize( QSize( 430, 32767 ) );
	QFont textLabel1_font( textLabel1->font() );
	textLabel1->setFont( textLabel1_font );

	einmessenLayout->addMultiCellWidget( textLabel1, 0, 0, 0, 2 );

	textLabel2_5 = new QLabel( einmessen, "textLabel2_5" );
	textLabel2_5->setMinimumSize( QSize( 430, 0 ) );
	textLabel2_5->setMaximumSize( QSize( 430, 32767 ) );
	QFont textLabel2_5_font( textLabel2_5->font() );
	textLabel2_5->setFont( textLabel2_5_font );

	einmessenLayout->addMultiCellWidget( textLabel2_5, 1, 1, 0, 2 );

	textLabel3_2_2 = new QLabel( einmessen, "textLabel3_2_2" );
	textLabel3_2_2->setMinimumSize( QSize( 105, 0 ) );
	textLabel3_2_2->setMaximumSize( QSize( 105, 32767 ) );
	QFont textLabel3_2_2_font( textLabel3_2_2->font() );
	textLabel3_2_2->setFont( textLabel3_2_2_font );

	einmessenLayout->addWidget( textLabel3_2_2, 2, 0 );

	z_referenz = new QPushButton( einmessen, "z_referenz" );
	z_referenz->setMinimumSize( QSize( 160, 30 ) );
	z_referenz->setMaximumSize( QSize( 160, 32767 ) );
	QFont z_referenz_font( z_referenz->font() );
	z_referenz->setFont( z_referenz_font );

	einmessenLayout->addMultiCellWidget( z_referenz, 2, 2, 1, 2 );

	textLabel2_5_3 = new QLabel( einmessen, "textLabel2_5_3" );
	textLabel2_5_3->setMinimumSize( QSize( 430, 0 ) );
	textLabel2_5_3->setMaximumSize( QSize( 430, 32767 ) );
	QFont textLabel2_5_3_font( textLabel2_5_3->font() );
	textLabel2_5_3->setFont( textLabel2_5_3_font );

	einmessenLayout->addMultiCellWidget( textLabel2_5_3, 3, 3, 0, 2 );

	textLabel2_5_3_2 = new QLabel( einmessen, "textLabel2_5_3_2" );
	textLabel2_5_3_2->setMinimumSize( QSize( 430, 0 ) );
	textLabel2_5_3_2->setMaximumSize( QSize( 430, 32767 ) );
	QFont textLabel2_5_3_2_font( textLabel2_5_3_2->font() );
	textLabel2_5_3_2->setFont( textLabel2_5_3_2_font );

	einmessenLayout->addMultiCellWidget( textLabel2_5_3_2, 4, 4, 0, 2 );

	textLabel3_2_2_2 = new QLabel( einmessen, "textLabel3_2_2_2" );
	textLabel3_2_2_2->setMinimumSize( QSize( 430, 30 ) );
	textLabel3_2_2_2->setMaximumSize( QSize( 430, 32767 ) );
	QFont textLabel3_2_2_2_font( textLabel3_2_2_2->font() );
	textLabel3_2_2_2->setFont( textLabel3_2_2_2_font );
	textLabel3_2_2_2->setAlignment( int ( QLabel::AlignVCenter | QLabel::AlignLeft ) );

	einmessenLayout->addMultiCellWidget( textLabel3_2_2_2, 5, 5, 0, 2 );

	textLabel3 = new QLabel( einmessen, "textLabel3" );
	textLabel3->setMinimumSize( QSize( 130, 25 ) );
	textLabel3->setMaximumSize( QSize( 130, 25 ) );
	einmessenLayout->addWidget( textLabel3, 6, 0 );

	differenz = new KIntNumInput( einmessen, "differenz" );
	einmessenLayout->addWidget( differenz, 6, 1 );

	textroot = new QLabel( einmessen, "textroot" );
	textroot->setMinimumSize( QSize( 430, 10 ) );
	textroot->setMaximumSize( QSize( 430, 10 ) );
	QFont textroot_font( textroot->font() );
	textroot_font.setPointSize( 8 );
	textroot->setFont( textroot_font );
	textroot->setAlignment( int ( QLabel::WordBreak | QLabel::AlignVCenter | QLabel::AlignLeft ) );

	einmessenLayout->addMultiCellWidget( textroot, 7, 7, 0, 2 );

	layout8 = new QGridLayout( 0, 1, 1, 0, 5, "layout8" );

	nach_unten_1 = new QPushButton( einmessen, "nach_unten_1" );
	nach_unten_1->setMinimumSize( QSize( 100, 30 ) );
	nach_unten_1->setMaximumSize( QSize( 32767, 30 ) );
	nach_unten_1->setPixmap( image2 );

	layout8->addWidget( nach_unten_1, 1, 0 );

	nach_oben_1 = new QPushButton( einmessen, "nach_oben_1" );
	nach_oben_1->setMinimumSize( QSize( 100, 30 ) );
	nach_oben_1->setMaximumSize( QSize( 32767, 30 ) );
	nach_oben_1->setPixmap( image3 );

	layout8->addWidget( nach_oben_1, 0, 0 );

	einmessenLayout->addMultiCellLayout( layout8, 8, 8, 0, 2 );

	layout9 = new QGridLayout( 0, 3, 2, 0, 5, "layout9" );

	textLabel2_6 = new QLabel( einmessen, "textLabel5" );
	textLabel2_6->setMinimumSize( QSize( 130, 30 ) );
	textLabel2_6->setMaximumSize( QSize( 130, 30 ) );
	QFont textLabel2_6_font( textLabel2_6->font() );
	textLabel2_6->setFont( textLabel2_6_font );
	layout9->addWidget( textLabel2_6, 0, 0 );

	distance = new KDoubleNumInput( einmessen, "distance" );
	distance->setValue( 0 );
	distance->setMinValue( -100.00 );
	distance->setMaxValue( 100.00 );
	layout9->addWidget( distance, 0, 1 );

	drive = new QPushButton( einmessen, "drive" );
	QFont drive_font( drive->font() );
	drive->setFont( drive_font );
	layout9->addWidget( drive, 0, 2 );

	text_vs = new QLabel( einmessen, "text_vs" );
	text_vs->setMinimumSize( QSize( 130, 30 ) );
	text_vs->setMaximumSize( QSize( 130, 30 ) );
	QFont text_vs_font( text_vs->font() );
	text_vs->setFont( text_vs_font );
	layout9->addWidget( text_vs, 1, 0 );

	vorschub = new KIntNumInput( einmessen, "vorschub" );
	vorschub->setValue( 1 );
	vorschub->setMinValue( 1 );
	layout9->addWidget( vorschub, 1, 1 );

	einmessenLayout->addMultiCellLayout( layout9, 9, 9, 0, 2 );


	line3 = new QFrame( einmessen, "line3" );
	line3->setFrameShape( QFrame::HLine );
	line3->setFrameShadow( QFrame::Sunken );
	line3->setFrameShape( QFrame::HLine );
	line3->setMaximumSize( QSize( 32767, 5 ) );

	einmessenLayout->addMultiCellWidget( line3, 10, 10, 0, 2 );


	textLabel5 = new QLabel( einmessen, "textLabel5" );
	QFont textLabel5_font( textLabel5->font() );
	textLabel5_font.setPointSize( 10 );
	textLabel5->setFont( textLabel5_font );
	textLabel5->setLineWidth( 1 );
	textLabel5->setAlignment( int ( QLabel::WordBreak | QLabel::AlignVCenter ) );

	einmessenLayout->addMultiCellWidget( textLabel5, 11, 11, 0, 2 );

	w_tab->insertTab( einmessen, QString::fromLatin1( "" ) );
	WerkzeugeLayout->addMultiCellWidget( w_tab, 2, 2, 0, 2 );

	m_combo = new QComboBox( FALSE, this, "m_combo" );
	m_combo->setMinimumSize( QSize( 0, 30 ) );
	m_combo->setAutoMask( TRUE );
	m_combo->setSizeLimit( 32 );
	m_combo->setMaxCount( 65535 );
	m_combo->setInsertionPolicy( QComboBox::AtBottom );
	m_combo->setAutoCompletion( FALSE );
	m_combo->setDuplicatesEnabled( FALSE );

	WerkzeugeLayout->addMultiCellWidget( m_combo, 0, 0, 0, 2 );

	w_combo = new QComboBox( FALSE, this, "w_combo" );
	w_combo->setMinimumSize( QSize( 0, 30 ) );
	w_combo->setAutoMask( TRUE );
	w_combo->setSizeLimit( 32 );
	w_combo->setMaxCount( 65535 );
	w_combo->setInsertionPolicy( QComboBox::AtBottom );
	w_combo->setAutoCompletion( FALSE );
	w_combo->setDuplicatesEnabled( FALSE );

	WerkzeugeLayout->addMultiCellWidget( w_combo, 1, 1, 0, 2 );
	languageChange();
	resize( QSize( 470, 700 ).expandedTo( minimumSizeHint() ) );
	clearWState( WState_Polished );

	// signals and slots connections
	connect( w_beenden, SIGNAL( clicked() ), this, SLOT( close() ) );
	connect( w_speichern, SIGNAL( clicked() ), this, SLOT( speichern_cklicked() ) );
	connect( w_abbruch, SIGNAL( clicked() ), this, SLOT( close() ) );
	connect( schrup, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( nach_o, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( nach_s, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( nach_u, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( unten_m, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( unten_a, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( seitlich_u, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( seitlich_o, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( klein, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( schlicht, SIGNAL( clicked() ), this, SLOT( check_ischanged() ) );
	connect( w_modul, SIGNAL( valueChanged( double ) ), this, SLOT( modul_changed() ) );
	connect( w_winkel, SIGNAL( valueChanged( double ) ), this, SLOT( winkel_changed() ) );
	connect( w_l2, SIGNAL( valueChanged( double ) ), this, SLOT( double_ischanged() ) );
	connect( w_durchmesser, SIGNAL( valueChanged( double ) ), this, SLOT( double_ischanged() ) );
	connect( w_l3, SIGNAL( valueChanged( double ) ), this, SLOT( double_ischanged() ) );
	connect( w_steigung, SIGNAL( valueChanged( double ) ), this, SLOT( steigung_changed() ) );
	connect( w_radius, SIGNAL( valueChanged( double ) ), this, SLOT( radius_changed() ) );
	connect( werkzeugname, SIGNAL( textChanged( const QString& ) ), this, SLOT( werkzeugname_changed() ) );
	connect( z_referenz, SIGNAL( clicked() ), this, SLOT( referenz_clicked() ) );
	connect( w_combo, SIGNAL( activated( int ) ), this, SLOT( w_combo_activated() ) );
	connect( m_combo, SIGNAL( activated( int ) ), this, SLOT( m_combo_activated() ) );
	connect( differenz, SIGNAL( valueChanged( int ) ), this, SLOT( changed() ) );
	connect( nach_oben_1, SIGNAL( pressed() ), this, SLOT( z1_o_pressed() ) );
	connect( nach_oben_1, SIGNAL( released() ), this, SLOT( z1_o_released() ) );
	connect( nach_unten_1, SIGNAL( pressed() ), this, SLOT( z1_u_pressed() ) );
	connect( nach_unten_1, SIGNAL( released() ), this, SLOT( z1_u_released() ) );
	connect( drive, SIGNAL( clicked() ), this, SLOT( drive_cklicked() ) );


	QDir::setCurrent( QDir::homeDirPath() + QString( "/PCNC" ) );
	werkzeuge = "";
	statusb = 0;
	GESPEICHERT = TRUE;
	COMBO = TRUE;
	MESSEN = FALSE;
	SELECTED = FALSE;
	aW = -1;
	aM = -1;
	maschinendatei = "maschinen.dat";

	QFile f2( maschinendatei );
	if ( f2.open( IO_ReadOnly ) )
		{
		QDataStream str( &f2 );
		int i = 0;
		while ( ! str.atEnd() )
			{
			str >> wname;
			m_combo->insertItem( QString( wname ), -1 );
			i++;
			f2.at( i * 128 );
			}
		m_combo->insertItem( "Maschinenauswahl", -1 );
		m_combo->setCurrentItem( m_combo->count() - 1 );
		if ( i == 0 )
			{
			KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Legen Sie erst eine Maschine an, damit sie Werkzeuge benutzen koenen !" ), "Fehler " );
			exit( -1 );
			}
		}
	else
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Sie haben moeglicherweise Ihre Maschinendatei geloescht !\nUm weiter arbeiten zu koennen muessen Sie neue Maschinen anlegen, oder diese Datei wieder herstellen !\n(%1)" ).arg( maschinendatei ), "Fehler " );
		exit( -1 );
		}
	f2.close();


	delay.tv_sec = 0;

	if ( 0 == getuid() )
		{
		RUN_M = FALSE;
		CLOSE_M = FALSE;
		int er = pthread_create( &th_m, NULL, move_th, this );
		if( er )
			KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Hoch, runter der Seite Einmessen funktioniert nicht\n Fehler: %1" ).arg( er ), "Fehler " );

		steuerung = new KProcess;
		steuerung->setUseShell( TRUE );
		}
	else
		{
		nach_oben_1->setEnabled( FALSE );
		nach_unten_1->setEnabled( FALSE );
		textroot->setText( "Sie haben keine Root-Rechte. Starten Sie das Werkzeugtool mit Ihrem Root-Passwort !" );
		drive->setEnabled( FALSE );
		}

	}

/*
 *  Destroys the object and frees any allocated resources
 */
WerkzeugeView::~WerkzeugeView()
	{
	}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void WerkzeugeView::languageChange()
	{
	setCaption( tr2i18n( "Werkzeuge einrichten" ) );
	w_abbruch->setText( tr2i18n( "Abbrechen" ) );
	w_beenden->setText( tr2i18n( "Beenden" ) );
	w_speichern->setText( tr2i18n( "Speichern" ) );
	w_speichern->setAccel( QKeySequence( QString::null ) );
	w_speichern->setFocus();
	textLabel7_3->setText( tr2i18n( "Werkzeugname:" ) );
	textLabel7_2_2->setText( tr2i18n( "Schräge Schneiden [ ° ]:" ) );
	textLabel2_4_2_2->setText( tr2i18n( "Steigung s [mm]:" ) );
	QToolTip::add( textLabel2_4_2_2, QString::null );
	textLabel2_4_3_2->setText( tr2i18n( "Modul m :" ) );
	textLabel2_2_2->setText( tr2i18n( "Schneiden-Länge l<font size=\"-1\">2</font> [mm]:" ) );
	QToolTip::add( werkzeugname, tr2i18n( "<p>Geben Sie hier den Namen ein,<br> der später in der Werkzeugauswahl erscheint.</p>" ) );
	QToolTip::add( w_radius, tr2i18n( "<table width=\"200\"><tr><td> r &#062; 0 = Radiusfräser </td></tr><tr><td> r &#060; 0 = Viertelrundfräser </td></tr></table>" ) );
	textLabel2_4_4->setText( tr2i18n( "Radius r [mm]:" ) );
	textLabel2_3_2->setText( tr2i18n( "Frei-Länge l<font size=\"-1\">3</font> [mm]:" ) );
	QToolTip::add( w_steigung, tr2i18n( "Der Gewindefräser kann diese<br> mittlere Steigung fräsen" ) );
	QToolTip::add( w_l3, tr2i18n( "<p>Tiefe des Bohrloches,<br>das mit diesem Fräser möglich wäre</p>" ) );
	textLabel2_7->setText( tr2i18n( "Durchmesser d<font size=\"-1\">1</font> [mm]:" ) );
	QToolTip::add( w_durchmesser, tr2i18n( "<p>Grösster Schneiden-Durchmesser</p>" ) );
	QToolTip::add( w_l2, tr2i18n( "<p>Länge der Schneiden</p>" ) );
	QToolTip::add( w_winkel, tr2i18n( "<table ><tr><td><b><center>+</center></b></td><td>= Fasenfräser</td></tr><tr><td><b><center>-</center></b></td><td>= Keilnutfräser</td></tr></table>" ) );
	QToolTip::add( w_modul, tr2i18n( "<p>Modul des Zanradfräsers</p>" ) );
	textLabel3_2->setText( tr2i18n( "<ul>\n"
	      "<li>Einmal abgespeicherte Werkzeuge können nicht mehr entfernt werden !</li>\n"
	      "<li>Sie können jedoch den Namen und die Werte der Werkzeuge jederzeit ändern.</li>\n"
	      "<li>Den Werkzeugnahmen sollten Sie so wählen, daß Sie das Werkzeug auch wieder erkennen.<br>\n"
	      "Z.B.: Langlochfräser D10-M -> <b>Langlochfräser</b> mit <b>D</b>urchmesser <b>10</b>mm und über <b>M</b>itte schneidend</li>\n"
	      "<li>Beschrifften Sie den Aufnahmekegel mit der Werkzeugnummer<br>\n"
	      "( Am besten einkravieren ).\n"
	      "</ul>" ) );
	w_tab->changeTab( form, tr2i18n( "Masse/Form" ) );
	schlicht->setText( tr2i18n( "Fr&äser für Schlichtarbeiten" ) );
	schlicht->setAccel( QKeySequence( tr2i18n( "Alt+ä" ) ) );
	klein->setText( tr2i18n( "Fräser mit geringem Durchmesser oder f&ür sehr hartes Material" ) );
	klein->setAccel( QKeySequence( tr2i18n( "Alt+ü" ) ) );
	seitlich_o->setText( tr2i18n( "Schneide&t seitlich nur oben (unten ist ein Hindernis)" ) );
	seitlich_o->setAccel( QKeySequence( tr2i18n( "Alt+T" ) ) );
	seitlich_u->setText( tr2i18n( "Schneidet seitlich unten (normaler Fräser)" ) );
	seitlich_u->setAccel( QKeySequence( QString::null ) );
	unten_a->setText( tr2i18n( "Schneidet nach &unten nur aussen" ) );
	unten_a->setAccel( QKeySequence( tr2i18n( "Alt+U" ) ) );
	unten_m->setText( tr2i18n( "Schneidet nach unten auch in der Mitte" ) );
	unten_m->setAccel( QKeySequence( QString::null ) );
	nach_u->setText( tr2i18n( "Schneiden &können nach unten arbeiten." ) );
	nach_u->setAccel( QKeySequence( tr2i18n( "Alt+K" ) ) );
	nach_s->setText( tr2i18n( "Schneiden k&önnen seitlich arbeiten" ) );
	nach_s->setAccel( QKeySequence( tr2i18n( "Alt+ö" ) ) );
	nach_o->setText( tr2i18n( "Schneiden können nach oben arbeiten" ) );
	textLabel3_2_3->setText( tr2i18n( "Es müssen hier die maximalen Fähigkeiten des Werkzeuges angekreutzt werden.<br>\n"
	      "Genauso dürfen aber auch keine Fähigkeiten hinzugedichtet werden.<br>\n"
	      "Z.B.:\n"
	      "Kann ein Fräser nicht eine Fläche ebenfräsen, dann hat er unten ein Hindernis\n"
	      "und wenn es noch so minimal ist. Oder ein Bohrer ist kein Fräser und kann weder\n"
	      "schruppen noch schlichten noch seitlich schneiden." ) );
	schrup->setText( tr2i18n( "Schrup-Fräser" ) );
	schrup->setAccel( QKeySequence( QString::null ) );
	w_tab->changeTab( verwendung, tr2i18n( "&Verwendung" ) );
	textLabel1->setText( tr2i18n( "1.) Spannen Sie das Tastwerkzeug ein." ) );
	textLabel2_5->setText( tr2i18n( "2.) Fahren das Tastwerkzeug auf die Oberfläche der Messuhr<br>\n"
	      " &nbsp; &nbsp; &nbsp;bis diese 0 anzeigt." ) );
	textLabel3_2_2->setText( tr2i18n( "3.) Drücken Sie" ) );
	textLabel2_5_3->setText( tr2i18n( "4.) Fahren Sie mit der Steuerung die Z-Achse nach oben.<br>\n"
	      " &nbsp; &nbsp; &nbsp;Spannen Sie das entsprechende Werkzeug ein und wählen<br>\n"
	      " &nbsp; &nbsp; &nbsp;Sie es oben aus." ) );
	textLabel2_5_3_2->setText( tr2i18n( "5.) Fahren Sie mit der Steuerung die Z-Achse nach unten bis<br>\n"
	      " &nbsp; &nbsp; &nbsp;die Tastuhr wieder 0 anzeigt." ) );
	nach_unten_1->setText( QString::null );
	nach_oben_1->setText( QString::null );
	textLabel5->setText( tr2i18n(
	         "<p>\n"
	         "Wollen Sie weitere Werkzeuge einmessen, dann fahren Sie nach dem abspeichern mit Punkt 4.) fort.\n"
	         "</p>\n"
	         "<table>\n"
	         "<tr>\n"
	         "<td><b>ACHTUNG :</b></td><td>Das Tastwerkzeug stellt die Referenz dar und darf nie,\n"
	         "solange Sie dieses Programm und diese Werkzeuge benutzen aus der Aufnahme ausgespannt werden !!!<br>\n"
	         "Das Tastwerkzeug darf nicht als Werkzeug abgespeichert werden.</td>\n"
	         "</tr>\n"
	         "</table>" ) );
	textroot->setText( tr2i18n( "1 Schritt = 0.005 mm,   1mm = 200 Schritte" ) );
	textLabel3_2_2_2->setText( tr2i18n( "6.) Speichern sie das Werkzeug ab - Fertig!" ) );
	textLabel3->setText( tr2i18n( "Differenz [Schritte] :" ) );
	z_referenz->setText( tr2i18n( "&Z-Referenz-OK" ) );
	z_referenz->setAccel( QKeySequence( tr2i18n( "Alt+Z" ) ) );
	textLabel2_6->setText( tr2i18n( "Z-Achse [mm] :" ) );
	drive->setText( tr2i18n( "Verfahren" ) );
	text_vs->setText( tr2i18n( "mit Vs [mm/min] :" ) );
	w_tab->changeTab( einmessen, tr2i18n( "Ei&nmessen" ) );
	m_combo->setCurrentItem( 0 );
	QToolTip::add( m_combo, tr2i18n( "Aktuelles Werkzeug, das Sie einrichten" ) );
	w_combo->clear();
	w_combo->insertItem( tr2i18n( "Neues Werkzeug" ) );
	w_combo->setCurrentItem( 0 );
	QToolTip::add( w_combo, tr2i18n( "Aktuelles Werkzeug, das Sie einrichten" ) );
	}


void WerkzeugeView::closeEvent( QCloseEvent *ce )
	{
	ce->accept();
	if ( ! GESPEICHERT )
		if ( 3 == KMessageBox::messageBox( 0, KMessageBox::QuestionYesNo, "Das Werkzeug war noch nicht abgespeichert.\nSpeichern ?", "Werkzeug ", KStdGuiItem::yes(), KStdGuiItem::no() ) )
			speichern_cklicked();

	exit( 0 );
	}

void WerkzeugeView::clearall()
	{
	werkzeugname->clear();

	w_durchmesser->setValue( 0.00 );
	w_l2->setValue( 0.00 );
	w_l3->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_modul->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_modul->setValue( 0.00 );
	w_winkel->setValue( 0.00 );

	schrup->setChecked( 0 );
	schlicht->setChecked( 0 );
	klein->setChecked( 0 );
	seitlich_o->setChecked( 0 );
	seitlich_u->setChecked( 0 );
	unten_a->setChecked( 0 );
	unten_m->setChecked( 0 );
	nach_u->setChecked( 0 );
	nach_s->setChecked( 0 );
	nach_o->setChecked( 0 );

	differenz->setValue( 0 );

	aW = -1;
	}

/** A record of a tool :
*0-36		37	byte	4length_33string	wname
*37-38		2	byte	verwendung		usage
*39-46		8	byte	w_durchmesser	diameter
*47-54		8	byte	w_l2				L2
*55-62		8	byte	w_l3				L3
*63-70		8	byte	extra				extra
*71-78		8	byte	double				difference
*-------
* 79 byte
*/
void WerkzeugeView::speichern_cklicked()
	{
	QFile f1( werkzeuge );
	if ( f1.open( IO_ReadOnly | IO_WriteOnly ) )
		{
		QDataStream str( &f1 );
		if ( aW == -1 )
			{
			KMessageBox::error( 0, QString( "Kein Werkzeug zu speichern !" ), "Fehler " );
			return;
			}
		else
			{
			f1.at( aW * 79 );

			Q_INT16 verwendung = 0;
			if ( schrup->isChecked() )
				verwendung = verwendung | F_SCHRUP;
			if ( schlicht->isChecked() )
				verwendung = verwendung | F_SCHLICHT;
			if ( klein->isChecked() )
				verwendung = verwendung | F_FEIN;
			if ( seitlich_o->isChecked() )
				verwendung = verwendung | F_SEITL_OBEN;
			if ( seitlich_u->isChecked() )
				verwendung = verwendung | F_SEITL;
			if ( unten_a->isChecked() )
				verwendung = verwendung | F_UNTEN_AUSSEN;
			if ( unten_m->isChecked() )
				verwendung = verwendung | F_UNTEN_MITTE | F_BOHRER;
			if ( nach_u->isChecked() )
				verwendung = verwendung | F_NACH_UNTEN;
			if ( nach_s->isChecked() )
				verwendung = verwendung | F_NACH_SEITL;
			if ( nach_o->isChecked() )
				verwendung = verwendung | F_NACH_OBEN;

			// double extra
			if ( w_steigung->value() > 0.00 )
				verwendung = verwendung | F_GEWINDE;
			if ( w_modul->value() > 0.00 )
				verwendung = verwendung | F_MODUL;
			if ( w_radius->value() > 0.00 )
				verwendung = verwendung | F_FORM;
			if ( w_radius->value() < 0.00 )
				verwendung = verwendung | F_VIERTELRUND;
			if ( w_winkel->value() != 0.00 )
				verwendung = verwendung | F_WINKEL;

			wname = werkzeugname->text().utf8();
			wname.resize( 33 );

			str << wname << verwendung << w_durchmesser->value() << w_l2->value() << w_l3->value();

			if ( verwendung & F_GEWINDE )
				str << w_steigung->value();
			else
				if ( verwendung & F_MODUL )
					str << w_modul->value();
				else
					if ( verwendung & ( F_FORM | F_VIERTELRUND ) )
						str << w_radius->value();
					else
						if ( verwendung & F_WINKEL )
							str << w_winkel->value();
						else
							{
							double d = 0.00;
							str << d;
							}
			delta = differenz->value();
			str << double( delta );
			}

		f1.close();
		GESPEICHERT = TRUE;
		KMessageBox::information( 0, QString( "Werkzeug wurde gespeichert !" ), "Info" );
		}
	}

/**
 *A maschinen record looks like this:
 *0-35		36		byte	name[32]
 *36		1		byte	play-x
 *37		1		byte	play-y
 *38		1		byte	play-z
 *39-40	2		byte	feed-x
 *41-42	2		byte	feed-y
 *43-44	2		byte	feed-z
 *45-46	2		byte	feed range-x
 *47-48	2		byte	feed range-y
 *49-50	2		byte	feed range-z
 *51		1		byte	options
 *52-53	2		byte	machine factor
 *54-55	2		byte	acceleration
 *56-91	36		byte	controlling programm
 *92-127	36		byte	tools file
 *-----------------------
 *			128	byte
 */
void WerkzeugeView::m_combo_activated()
	{
	if ( ! GESPEICHERT )
		if ( 3 == KMessageBox::messageBox( 0, KMessageBox::QuestionYesNo, "Das Werkzeug war noch nicht abgespeichert.\nSpeichern ?", "Werkzeug ", KStdGuiItem::yes(), KStdGuiItem::no() ) )
			speichern_cklicked();

	GESPEICHERT = TRUE;
	COMBO = TRUE;

	if ( ! SELECTED )
		{
		m_combo->removeItem( m_combo->count() - 1 );
		SELECTED = TRUE;
		}

	QFile f2( maschinendatei );
	if ( f2.open( IO_ReadOnly ) )
		{
		QDataStream str( &f2 );
		aM = m_combo->currentItem();
		f2.at( aM * 128 );
		str >> wname >> b >> b >> b >> w >> w >> max_speed_z >> w >> w >> range_z >> b >> mfactor >> acceleration >> sdat >> wdat;
		werkzeuge = wdat;
		vorschub->setMaxValue( max_speed_z );
		vorschub->setValue( max_speed_z / 2 );
		clearall();
		}
	f2.close();

	distance->setMinValue( -range_z );
	distance->setMaxValue( range_z );

	QFile f1( werkzeuge );
	if ( f1.open( IO_ReadWrite ) )
		{
		QDataStream str( &f1 );
		int i = 0;
		w_combo->clear();
		w_combo->insertItem( "Neues Werkzeug" );
		while ( ! str.atEnd() )
			{
			str >> wname;
			w_combo->insertItem( "(" + QString::number( i ) + ") " + QString( wname ), -1 );
			i++;
			f1.at( i * 79 );
			}
		}
	f1.close();
	}


void WerkzeugeView::w_combo_activated()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Wählen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geöffnet werden kann !" ), "Fehler " );
		return;
		}

	if ( aW == ( w_combo->currentItem() - 1 ) && aW != -1 )
		return;

	COMBO = TRUE;
	if ( ! GESPEICHERT )
		if ( KMessageBox::Yes == KMessageBox::questionYesNo( 0, "Das Werkzeug war noch nicht abgespeichert.\nSpeichern ?", "Werkzeug ", KStdGuiItem::yes(), KStdGuiItem::no() ) )
			speichern_cklicked();

	GESPEICHERT = TRUE;

	QFile f1( werkzeuge );
	if ( f1.open( IO_ReadOnly ) )
		{
		QDataStream str( &f1 );
		aW = w_combo->currentItem() - 1;
		if ( aW != -1 )
			{
			f1.at(( aW ) * 79 );

			Q_INT16 verwendung;
			double durchmesser;
			double l2;
			double l3;
			double r_s_m_w;
			double delta_in;

			str >> wname >> verwendung >> durchmesser >> l2 >> l3 >> r_s_m_w >> delta_in;

			werkzeugname->setText( wname );
			w_durchmesser->setValue( durchmesser );
			w_l2->setValue( l2 );
			w_l3->setValue( l3 );

			w_radius->setValue( 0.00 );
			w_steigung->setValue( 0.00 );
			w_modul->setValue( 0.00 );
			w_winkel->setValue( 0.00 );

			if ( 1 && verwendung & F_GEWINDE )
				w_steigung->setValue( r_s_m_w );
			else
				if ( 1 && verwendung & F_MODUL )
					w_modul->setValue( r_s_m_w );
				else
					if ( 1 && verwendung & ( F_FORM | F_VIERTELRUND ) )
						w_radius->setValue( r_s_m_w );
					else
						if ( 1 && verwendung & F_WINKEL )
							w_winkel->setValue( r_s_m_w );


			if ( 1 && verwendung & F_SCHRUP )
				schrup->setChecked( 1 );
			else
				schrup->setChecked( 0 );
			if ( 1 && verwendung & F_SCHLICHT )
				schlicht->setChecked( 1 );
			else
				schlicht->setChecked( 0 );
			if ( 1 && verwendung & F_FEIN )
				klein->setChecked( 1 );
			else
				klein->setChecked( 0 );
			if ( 1 && verwendung & F_SEITL_OBEN )
				seitlich_o->setChecked( 1 );
			else
				seitlich_o->setChecked( 0 );
			if ( 1 && verwendung & F_SEITL )
				seitlich_u->setChecked( 1 );
			else
				seitlich_u->setChecked( 0 );
			if ( 1 && verwendung & F_UNTEN_AUSSEN )
				unten_a->setChecked( 1 );
			else
				unten_a->setChecked( 0 );
			if ( 1 && verwendung & F_UNTEN_MITTE )
				unten_m->setChecked( 1 );
			else
				unten_m->setChecked( 0 );
			if ( 1 && verwendung & F_NACH_UNTEN )
				nach_u->setChecked( 1 );
			else
				nach_u->setChecked( 0 );
			if ( 1 && verwendung & F_NACH_SEITL )
				nach_s->setChecked( 1 );
			else
				nach_s->setChecked( 0 );
			if ( 1 && verwendung & F_NACH_OBEN )
				nach_o->setChecked( 1 );
			else
				nach_o->setChecked( 0 );

			differenz->setValue( int ( delta_in ) );
			}
		else
			{
			clearall();
			aW = w_combo->count() - 1;
			w_combo->insertItem( "(" + QString::number( aW ) + ") " + "Neu", -1 );
			w_combo->setCurrentItem( aW + 1 );
			w_tab->setCurrentPage( 0 );
			werkzeugname->setFocus();
			GESPEICHERT = FALSE;
			}
		}
	f1.close();
	COMBO = FALSE;
	}


void WerkzeugeView::werkzeugname_changed()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	if ( aW != -1 )
		w_combo->changeItem( "(" + QString::number( aW ) + ") " + werkzeugname->text(), aW + 1 );

	GESPEICHERT = COMBO;
	}


void WerkzeugeView::double_ischanged()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	GESPEICHERT = COMBO;
	}


void WerkzeugeView::radius_changed()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	w_modul->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_winkel->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}


void WerkzeugeView::steigung_changed()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	w_modul->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	w_winkel->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::modul_changed()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	w_steigung->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	w_winkel->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::winkel_changed()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	w_modul->setValue( 0.00 );
	w_steigung->setValue( 0.00 );
	w_radius->setValue( 0.00 );
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::check_ischanged()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	GESPEICHERT = COMBO;
	}

void WerkzeugeView::referenz_clicked()
	{
	if ( aM == -1 )
		{
		KMessageBox::messageBox( 0, KMessageBox::Information, QString( "Waehlen Sie zuerst eine Maschinen aus,\n damit die entsprechende Werkzeugdatei geoeffnet werden kann !" ), "Fehler " );
		return;
		}

	MESSEN = TRUE;
	delta = 0;
	differenz->setValue( delta );
	}


void WerkzeugeView::changed()
	{
	GESPEICHERT = COMBO;
	}

void WerkzeugeView::beenden_cklicked()
	{
	}

void * WerkzeugeView::move_th( void * parent )
	{
	WerkzeugeView *p = (( WerkzeugeView* ) parent );
	timespec dl, rest;

	dl.tv_sec = 0;
	dl.tv_nsec = 50000000;
	p->CLOSE_M = FALSE;

	while ( ! p->CLOSE_M )
		{
		if ( p->RUN_M )
			{
			if ( p->UP_M )
				{
				if ( p->aM != -1 && p->MESSEN )
					{
					system( "m1o" );
					p->delta ++;
					p->differenz->setValue( p->delta );
					}
				else
					system( "m1o" );
				}
			else
				{
				if ( p->aM != -1 && p->MESSEN )
					{
					system( "m1u" );
					p->delta --;
					p->differenz->setValue( p->delta );
					}
				else
					system( "m1u" );
				}

			nanosleep( &dl, &rest );
			}
		}
	
	pthread_exit(0);
	}

void WerkzeugeView::z1_o_pressed()
	{
	UP_M = TRUE;
	RUN_M = TRUE;
	}

void WerkzeugeView::z1_o_released()
	{
	RUN_M = FALSE;
	}

void WerkzeugeView::z1_u_pressed()
	{
	UP_M = FALSE;
	RUN_M = TRUE;
	}

void WerkzeugeView::z1_u_released()
	{
	RUN_M = FALSE;
	}

void WerkzeugeView::drive_cklicked()
	{
	QFile f1( "nc.tmp" );
	Q_INT32 d32;
	int driven;

	CLOSE_M = TRUE;
	
	if ( f1.open( IO_ReadWrite | IO_Truncate ) )
		{
		QDataStream str( &f1 );
		str.setByteOrder( QDataStream::LittleEndian );
		Q_UINT8 c = 0;
		b = 19;
		str << b << acceleration;
		b = 15;
		d32 = 150000 * mfactor / vorschub->value();
		str << b << d32;
		b = 4;
		d32 = round( 100 * distance->value() * mfactor );
		driven = d32;
		if ( d32 < 0 )
			{
			c = c | bit2;
			d32 = -d32;
			}
		str << b << c << d32;
		str << ( int ) 0;
		}
	f1.close();

	*steuerung << "konsole" << " --notabbar --nomenubar -e " << sdat;
	
	if ( ! steuerung->isRunning() )
		{
		
		if ( ! steuerung->start( KProcess::Block ) )
			{
			steuerung->kill();
			KMessageBox::messageBox( 0, KMessageBox::Error, QString( "<p>Konnte die Steuerung nicht starten <br><center>Fehler : %1</center></p>" ).arg( steuerung->exitStatus() ), "Fehler " );
			return;
			}
		
		GESPEICHERT = COMBO;
		delta = delta + driven;
		differenz->setValue( delta );
		
		pthread_create( &th_m, NULL, move_th, this );
		return;
		}
	}

#include "werkzeugeview.moc"

